.\"remove .ig hn for full docs
.de hi
.ig eh
..
.de eh
..
.TH "" 3 "" "Version 3.0" "Free Widget Foundation"
.SH NAME
XfwfMenuBar
.SH DESCRIPTION
The MenuBar widget is a special kind of RowCol widget. It assumes
that all its children are PullDown buttons or other widgets that pop
up a menu. (But nothing will break if they are not.)  By default, the
children are arranged in a row, wrapping to the next row if the width
is not enough for all of them. But other arrangements are possible,
see the resources of the XfwfRowCol(3) widget.

The MenuBar attaches itself to the \fIpopup\fP callback of the menu shell
that is popped up by the children, and inserts itself in the list of
pointer grabs that Xt maintains. This is necessary to be able to drag
the mouse from one menu into another, popping down the first one and
popping up the second. If you use a RowCol widget instead of a
MenuBar, you will find that switching from one menu to the next
involves releasing the mouse and then pressing it again.

To find the menu shell, the children are asked for their \fIpopup\fP
resource. PullDown buttons have this resource, others may not.

The MenuBar widget introduces no new resources.

.SS "Public variables"

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfMenuBar
Name	Class	Type	Default

.TE
.ps

.TP
.I "XtNframeType"

.hi

.nf
 frameType = XfwfRaised 
.fi

.eh

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfRowCol
Name	Class	Type	Default
XtNstoreByRow	XtCStoreByRow	Boolean 	True 
XtNrows	XtCRows	Cardinal 	0 
XtNcolumns	XtCColumns	Cardinal 	0 
XtNspacing	XtCSpacing	Cardinal 	3 
XtNalignment	XtCAlignment	Alignment 	XfwfTopLeft 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfBoard
Name	Class	Type	Default
XtNabs_x	XtCAbs_x	Int 	0 
XtNrel_x	XtCRel_x	Float 	"0.0"
XtNabs_y	XtCAbs_y	Int 	0 
XtNrel_y	XtCRel_y	Float 	"0.0"
XtNabs_width	XtCAbs_width	Int 	0 
XtNrel_width	XtCRel_width	Float 	"1.0"
XtNabs_height	XtCAbs_height	Int 	0 
XtNrel_height	XtCRel_height	Float 	"1.0"
XtNhunit	XtCHunit	Float 	"1.0"
XtNvunit	XtCVunit	Float 	"1.0"
XtNlocation	XtCLocation	String 	NULL 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfFrame
Name	Class	Type	Default
XtNcursor	XtCCursor	Cursor 	None 
XtNframeType	XtCFrameType	FrameType 	XfwfRaised 
XtNframeWidth	XtCFrameWidth	Dimension 	0 
XtNframeOffset	XtCFrameOffset	Dimension 	0 
XtNshadowScheme	XtCShadowScheme	ShadowScheme 	XfwfAuto 
XtNlightColor	XtCLightColor	Pixel 	XtDefaultBackground 
XtNdarkColor	XtCDarkColor	Pixel 	XtDefaultForeground 
XtNlightStipple	XtCLightStipple	Bitmap 	NULL 
XtNdarkStipple	XtCDarkStipple	Bitmap 	NULL 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfCommon
Name	Class	Type	Default
XtNtraversalOn	XtCTraversalOn	Boolean 	True 
XtNhighlightThickness	XtCHighlightThickness	Dimension 	2 
XtNhighlightColor	XtCHighlightColor	Pixel 	XtDefaultForeground 
XtNhighlightPixmap	XtCHighlightPixmap	Pixmap 	None 
XtNnextTop	XtCNextTop	Callback	NULL 
XtNuserData	XtCUserData	Pointer	NULL 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
Composite
Name	Class	Type	Default
XtNchildren	XtCChildren	WidgetList 	NULL 
insertPosition	XtCInsertPosition	XTOrderProc 	NULL 
numChildren	XtCNumChildren	Cardinal 	0 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
Core
Name	Class	Type	Default
XtNx	XtCX	Position 	0 
XtNy	XtCY	Position 	0 
XtNwidth	XtCWidth	Dimension 	0 
XtNheight	XtCHeight	Dimension 	0 
borderWidth	XtCBorderWidth	Dimension 	0 
XtNcolormap	XtCColormap	Colormap 	NULL 
XtNdepth	XtCDepth	Int 	0 
destroyCallback	XtCDestroyCallback	XTCallbackList 	NULL 
XtNsensitive	XtCSensitive	Boolean 	True 
XtNtranslations	XtCTranslations	XTTranslations 	NULL 
ancestorSensitive	XtCAncestorSensitive	Boolean 	False 
accelerators	XtCAccelerators	XTTranslations 	NULL 
borderColor	XtCBorderColor	Pixel 	0 
borderPixmap	XtCBorderPixmap	Pixmap 	NULL 
background	XtCBackground	Pixel 	0 
backgroundPixmap	XtCBackgroundPixmap	Pixmap 	NULL 
mappedWhenManaged	XtCMappedWhenManaged	Boolean 	True 
XtNscreen	XtCScreen	Screen *	NULL 

.TE
.ps

.SS "Translations"

Since the MenuBar widget adds itself to the list of cascaded pop
ups that is maintained by Xt, it will receive pointer events when a
menu is popped up. If the event is a button release, the menu will
have to be popped down.

.nf
<Btn1Up>: menu_popdown() 
.fi

.hi
.SS "Actions"

.TP
.I "menu_popdown

The \fImenu_popdown\fP action calls \fIXtPopdown\fP for the current menu,
if there is one.

.hi

.nf
void menu_popdown($, XEvent* event, String* params, Cardinal* num_params)
{
    if ($current_menu != NULL) {
	XtPopdown($current_menu);
	$current_menu = NULL;
    }
}
.fi

.eh

.hi

.hi
.SH "Importss"

For the definition of \fIXtNpopup\fP we need the header file for the
PullDown widget.

.nf

.B incl
 <Xfwf/PullDown.h>
.fi

.nf

.B incl
 <stdio.h>
.fi

.hi

.hi
.SS "Private variables"

When the \fImenu_callback\fP function is called, it tries to get the ID
of the popped up widget.  If it succeeds, the ID is stored in a
private variable, so that the widget can be popped down again, if
another menu pops up.

.nf
Widget  current_menu
.fi

.hi

.hi
.SS "Methods"

The \fIcurrent_menu\fP variable is intialized to \fINULL\fP by the
\fIinitialize\fP method.

.nf
initialize(Widget  request, $, ArgList  args, Cardinal * num_args)
{
    $current_menu = NULL;
}
.fi

When a new child is added, it is added normally by the superclass's
method, but then a callback is added for the \fIactivate\fP of
the child and the \fIpopdownCallback\fP of the child's menu. This
callback is defined in the Shell widget. The child's menu is named
\fIpopup\fP in Pulldown buttons, thus it will only work for them or their
subclasses.

.nf
insert_child(Widget  child)
{
    Widget popup = NULL;

    #insert_child(child);
    XtVaGetValues(child, XtNpopup, popup, NULL);
    if (popup) {
	XtAddCallback(child, XtNactivate, menu_popup_cb, $);
	XtAddCallback(popup, XtNpopdownCallback, menu_popdown_cb, $);
    }
}
.fi

.hi

.hi
.SH "Utilities"

.nf
char  rcsid[] = "$Ident$"
.fi

The callback \fImenu_popup_cb\fP is attached to the \fIactivate\fP callback
of a (PullDown) button. The \fImenu_popup_cb\fP routine establishes a new
grab, overriding the one exerted by the menu, and adds the MenuBar
widget in the list of cascaded menus that is maintained by Xt. This
will ensure that pointer events continue to arrive at the MenuBar
widget.

.nf
menu_popup_cb(Widget  w, XtPointer  client_data, XtPointer  call_data)
{
    Widget $ = (Widget) client_data, menu = NULL;
    Cursor cursor;

    XtVaGetValues(w, XtNpopup, menu, NULL);
    if (menu  $current_menu == menu) return;	/* Already popped up */
    if ($current_menu) XtPopdown($current_menu);
    $current_menu = menu;
    XtVaGetValues(w, XtNmenuCursor, cursor, NULL);
    XtGrabPointer($, True, EnterWindowMask | LeaveWindowMask |
		  ButtonPressMask | ButtonReleaseMask, GrabModeAsync,
		  GrabModeAsync, None, cursor, CurrentTime);
    XtAddGrab($, True, False);
}
.fi

When a menu is popped down again,the \fImenu_popdown_cb\fP function
will be called. It removes the MenuBarwidget from the cascade list
and resets \fIcurrent_menu\fP to \fINULL\fP.

.nf
menu_popdown_cb(Widget  w, XtPointer  client_data, XtPointer  call_data)
{
    Widget $ = (Widget) client_data;

    $current_menu = NULL;
    /* XtRemoveGrab($); */
    XtUngrabPointer($, CurrentTime);
}
.fi

.hi
