.\"remove .ig hn for full docs
.de hi
.ig eh
..
.de eh
..
.TH "" 3 "" "Version 3.0" "Free Widget Foundation"
.SH NAME
XfwfToggle
.SH DESCRIPTION
The \fIXfwfToggle\fP is a button that switches states with every activation
(which is by default with every mouse click). The states are named `on' and
`off'. The states can be indicated with a $\surd$ before the label Two
callbacks report the changed state to the application: \fIonCallback\fP is called
when the button switches to `on', \fIoffCallback\fP is called when the button
switches back to `off'.

.SS "Public variables"

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfToggle
Name	Class	Type	Default
XtNonCallback	XtCOnCallback	Callback	NULL 
XtNoffCallback	XtCOffCallback	Callback	NULL 
XtNtickmark	XtCTickmark	Boolean 	True 
XtNon	XtCOn	Boolean 	False 

.TE
.ps

.TP
.I "XtNonCallback"
The \fIonCallback\fP is called by the \fItoggle\fP action or by the \fIswitch_on\fP
action, if the previous state was `off'. The \fIcall_data\fP argument will contain
the \fIXEvent\fP pointer that trigerred the action function.

.hi

.nf
<Callback> XtCallbackList  onCallback = NULL 
.fi

.eh

.TP
.I "XtNoffCallback"
The \fIoffCallback\fP is called from the \fItoggle\fP or \fIswitch_off\fP action, if the
previous state was `on'. The \fIcall_data\fP argument will be a pointer to the
\fIXEvent\fP that caused the action.

.hi

.nf
<Callback> XtCallbackList  offCallback = NULL 
.fi

.eh

.TP
.I "XtNtickmark"
The \fItickmark\fP resource controls whether the label in the button will be
prefixed with a tick mark $\surd$ in the `on' state. If \fItickmark\fP is \fIFalse\fP,
the application should find some other means of indicating the state, e.g, by
changing the label.

.hi

.nf
Boolean  tickmark = True 
.fi

.eh

.TP
.I "XtNon"
The variable \fIon\fP records the state of the widget: \fITrue\fP means `on' and
\fIFalse\fP means `off'.

.hi

.nf
Boolean  on = False 
.fi

.eh

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfButton
Name	Class	Type	Default
XtNactivate	XtCActivate	Callback	NULL 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfLabel
Name	Class	Type	Default
XtNlabel	XtCLabel	String 	NULL 
XtNfont	XtCFont	FontStruct	XtDefaultFont 
XtNforeground	XtCForeground	Pixel 	XtDefaultForeground 
XtNalignment	XtCAlignment	Alignment 	0 
XtNmargin	XtCMargin	Int 	2 
XtNshrinkToFit	XtCShrinkToFit	Boolean 	False 
XtNrvStart	XtCRvStart	Int 	0 
XtNrvLength	XtCRvLength	Int 	0 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfBoard
Name	Class	Type	Default
XtNabs_x	XtCAbs_x	Int 	0 
XtNrel_x	XtCRel_x	Float 	"0.0"
XtNabs_y	XtCAbs_y	Int 	0 
XtNrel_y	XtCRel_y	Float 	"0.0"
XtNabs_width	XtCAbs_width	Int 	0 
XtNrel_width	XtCRel_width	Float 	"1.0"
XtNabs_height	XtCAbs_height	Int 	0 
XtNrel_height	XtCRel_height	Float 	"1.0"
XtNhunit	XtCHunit	Float 	"1.0"
XtNvunit	XtCVunit	Float 	"1.0"
XtNlocation	XtCLocation	String 	NULL 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfFrame
Name	Class	Type	Default
XtNcursor	XtCCursor	Cursor 	None 
XtNframeType	XtCFrameType	FrameType 	XfwfRaised 
XtNframeWidth	XtCFrameWidth	Dimension 	0 
XtNframeOffset	XtCFrameOffset	Dimension 	0 
XtNshadowScheme	XtCShadowScheme	ShadowScheme 	XfwfAuto 
XtNlightColor	XtCLightColor	Pixel 	XtDefaultBackground 
XtNdarkColor	XtCDarkColor	Pixel 	XtDefaultForeground 
XtNlightStipple	XtCLightStipple	Bitmap 	NULL 
XtNdarkStipple	XtCDarkStipple	Bitmap 	NULL 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
XfwfCommon
Name	Class	Type	Default
XtNtraversalOn	XtCTraversalOn	Boolean 	True 
XtNhighlightThickness	XtCHighlightThickness	Dimension 	2 
XtNhighlightColor	XtCHighlightColor	Pixel 	XtDefaultForeground 
XtNhighlightPixmap	XtCHighlightPixmap	Pixmap 	None 
XtNnextTop	XtCNextTop	Callback	NULL 
XtNuserData	XtCUserData	Pointer	NULL 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
Composite
Name	Class	Type	Default
XtNchildren	XtCChildren	WidgetList 	NULL 
insertPosition	XtCInsertPosition	XTOrderProc 	NULL 
numChildren	XtCNumChildren	Cardinal 	0 

.TE
.ps

.ps-2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
Core
Name	Class	Type	Default
XtNx	XtCX	Position 	0 
XtNy	XtCY	Position 	0 
XtNwidth	XtCWidth	Dimension 	0 
XtNheight	XtCHeight	Dimension 	0 
borderWidth	XtCBorderWidth	Dimension 	0 
XtNcolormap	XtCColormap	Colormap 	NULL 
XtNdepth	XtCDepth	Int 	0 
destroyCallback	XtCDestroyCallback	XTCallbackList 	NULL 
XtNsensitive	XtCSensitive	Boolean 	True 
XtNtranslations	XtCTranslations	XTTranslations 	NULL 
ancestorSensitive	XtCAncestorSensitive	Boolean 	False 
accelerators	XtCAccelerators	XTTranslations 	NULL 
borderColor	XtCBorderColor	Pixel 	0 
borderPixmap	XtCBorderPixmap	Pixmap 	NULL 
background	XtCBackground	Pixel 	0 
backgroundPixmap	XtCBackgroundPixmap	Pixmap 	NULL 
mappedWhenManaged	XtCMappedWhenManaged	Boolean 	True 
XtNscreen	XtCScreen	Screen *	NULL 

.TE
.ps

.SS "Translations"

The \fItoggle\fP action toggles the widget between `on' and `off'. By
default it is bound to a click of the left mouse button as well as to
the Return key.

.nf
<Btn1Down>,<Btn1Up>: toggle() 
.fi

.nf
<Key>Return: toggle() 
.fi

.hi
.SS "Actions"

.TP
.I "toggle

The \fItoggle\fP action switches the state. Depending on the resources \fItickmark\fP
and \fIinvert\fP it might change the label or the colors or both. The \fIonCallback\fP
or \fIoffCallback\fP functions are called, with the event as \fIcall_data\fP argument.

.hi

.nf
void toggle($, XEvent* event, String* params, Cardinal* num_params)
{
    XtVaSetValues($, "on", !$on, NULL);
    XtCallCallbackList($, $on ? $onCallback : $offCallback, event);
}
.fi

.eh

.TP
.I "switch_on

The \fIswitch_on\fP action switches the button to `on' if it is `off', otherwise
it does nothing. By default it isn't bound to any event. If the widget is
changed, the \fIonCallback\fP is called with the event as \fIcall_data\fP.

.hi

.nf
void switch_on($, XEvent* event, String* params, Cardinal* num_params)
{
    if (! $on) {
        XtVaSetValues($, "on", True, NULL);
        XtCallCallbackList($, $onCallback, event);
    }
}
.fi

.eh

.TP
.I "switch_off

The \fIswitch_off\fP action switches the widget to `off' if the state is `on',
otherwise it does nothing. When the widget changes states, the \fIoffCallback\fP
is called, with a pointer to the \fIXEvent\fP structure as \fIcall_data\fP argument.

.hi

.nf
void switch_off($, XEvent* event, String* params, Cardinal* num_params)
{
    if ($on) {
        XtVaSetValues($, "on", False, NULL);
        XtCallCallbackList($, $offCallback, event);
    }
}
.fi

.eh

.hi

.hi
.SH "Importss"

.nf

.B incl
 "tick.bm"
.fi

.hi

.hi
.SS "Private variables"

The \fItickgc\fP GC holds the picture of a tick mark as a stipple.

.nf
GC  tickgc
.fi

.hi

.hi
.SS "Methods"

The tick mark is a small bitmap that is created in a utility function
and put into a GC called \fItickgc\fP.

.nf
initialize(Widget  request, $, ArgList  args, Cardinal * num_args)
{
    $tickgc = NULL;
    create_tickgc($);
}
.fi

When the \fIon\fP resource changes, the \fIset_values\fP method inspects the
\fItickmark\fP resource to see if the widget needs to be redrawn (to add or remove
the tick mark).

.nf
Boolean  set_values(Widget  old, Widget  request, $, ArgList  args, Cardinal * num_args)
{
    if ($foreground != $old$foreground)
        create_tickgc($);
    if ($on != $old$on  $tickmark)
        return True;
    else
        return False;
}
.fi

The \fIexpose\fP method uses the \fIexpose\fP method of the superclass to draw the
button and then possibly adds a tick mark.

.nf
expose($, XEvent * event, Region  region)
{
    Position x, y;
    Dimension w, h;

    if (! XtIsRealized($)) return;
    #expose($, event, region);
    if ($tickmark  $on) {
        $compute_inside($, x, y, w, h);
        y = y + (h - tick_height)/2;
	XSetTSOrigin(XtDisplay($), $tickgc, x, y);
        XFillRectangle(XtDisplay($), XtWindow($), $tickgc, x, y,
            tick_width, tick_height);
    }
}
.fi

.hi

.hi
.SH "Utilities"

The \fIcreate_tickgc\fP function creates a GC with the tick mark bitmap as a
stipple and the \fIforeground_pixel\fP as the foreground.

.nf
create_tickgc($)
{
    XtGCMask mask;
    XGCValues values;

    if ($tickgc != NULL) XtReleaseGC($, $tickgc);
    mask = GCForeground | GCStipple | GCFillStyle;
    values.foreground = $foreground;
    values.stipple = XCreateBitmapFromData(XtDisplay($),
        RootWindowOfScreen(XtScreen($)), tick_bits, tick_width, tick_height);
    if (! values.stipple) XtError("Couldn't create bitmap for tick mark");
    values.fill_style = FillStippled;
    $tickgc = XtGetGC($, mask, values);
}
.fi

.hi
